/**
 * Auther: Y.Inui@tci
 * Date: 16/04/12
 * Update: 16/06/01
 * Ver: 160601
 * To change this template use File | Settings | File Templates.
 * 16/04/12:Y.Inui@tci ... release
 * 16/04/20:Y.Inui@tci ... remove Google Analytics関連機能
 * 16/05/13:Y.Inui@tci ... bug fix
 * 16/06/01:Y.Inui@tci ... bug fix ヘッダー読み込み時のscriptタグ移植部分修正 charcodeの項目が元々存在しなければ、一つ手前のsrc属性の中身が反映されるため
 */

/**
 * CAUTION! ========== CAUTION! =========== CAUTION! =========== CAUTION!
 * このファイルはサーバ内に一つのみにしてください！
 * サイトやHTML毎に個別につくるのはこのファイルをTemplateにして継承したものにしてください。
 * このファイルへの変更はすべてのサイトに影響します、変更希望は技術チームにご依頼ください。
 * このファイルを公開サーバへアップロードする場合は必ずシュリンクしてからにしてください。
 * 「http://dean.edwards.name/packer/」Base62 encodeにのみチェックを入れてPack
 */

/**
 * 初期設定
 * @constructor
 */
var SprtTvInit = function() { this.initialize.apply(this, arguments); };
SprtTvInit.prototype = {
    initialize: function()
    {
        var judgement = new BrowserJudgement();
        judgement.judge();
        this._arguments = this._setArguments();
        this._arguments['browser'] = judgement.getResult();
        this._arguments['interceptor'] = new DefaultEventInterceptor();
        this._arguments['currentDate'] = new Date();
        this._arguments['uriParam'] = new UriParam();
        this._arguments['outerServerIP'] = 'www.asahi.co.jp';
        this._arguments['innerFlg'] = false;
        this._arguments['innerDir'] = ''; // ラジオのabc1008ディレクトリのようにroot以下に擬似rootディレクトリを設ける場合に
        this._arguments['rootPath'] = '/';
        this._detectBasePath(); // 該当サイトのルートディレクトリを設定
        this._arguments['depth'] = this._getDirectoryDepth(this._arguments.rootPath);
        this._arguments['siteDepth'] = this._getDirectoryDepth(this._arguments.basePath);
        this._arguments['status'] = {
            mode: 'normal'
            , date: new Date()
        };
        this._arguments['uriParam'].execute();
        if (typeof this._arguments['uriParam'].get('mode') !== 'undefined' && this._arguments.innerFlg === true) {
            this._arguments['status'].mode = 'debug';
            var year = Number(this._arguments.uriParam.get('date').substr(0, 4));
            var month = Number(this._arguments.uriParam.get('date').substr(4, 2)) - 1;
            var date = Number(this._arguments.uriParam.get('date').substr(6, 2));
            var hour = Number(this._arguments.uriParam.get('date').substr(8, 2));
            var minutes = Number(this._arguments.uriParam.get('date').substr(10, 2));
            this._arguments['status'].date = new Date(year, month, date, hour, minutes, 0);
        }
    },

    _setArguments: function()
    {
        return {
            basePath: '/' // サイトを設置するディレクトリのフルパス
            , headerUriPc: '/header/header_utf8.html'
            , smpFooter: false
            , tanpatsuPage: false
            , header: false
            , imgReplace: false
            //, analyticsSelector: 'none' // none/pc/smp/both
            //, analyticsParam: 'main'
            , snsLinkSelector: 'none' // none/pc/smp/both
            , snsLinkPlaceHolderID: 'snslink'
            , fbTitle: ''
            , twMain: ''
            // 切り替え画像一覧
            , ImgList: [
                {
                    id: 'replaceLogo'
                    , className: ''
                    , pc: 'img/pc/logo_main.jpg'
                    , smp: 'img/smp/logo_main.jpg'
                }
                , {
                    id: 'replaceOaDate'
                    , className: ''
                    , pc: 'img/pc/txt_oa_date.png'
                    , smp: 'img/smp/txt_oa_date.png'
                }
            ]
        };
    },

    get: function(name)
    {
        if (name === 'currentDate' && this._arguments.status.mode === 'debug') {
            return this._arguments.status.date;
        }
        return this._arguments[name];
    },

    set: function(name, value)
    {
        this._arguments[name] = value;
    },

    _detectBasePath: function()
    {
        var basePath = '/';
        var pathStrings = location.pathname.split('/');
        var i = 0;
        if (this._arguments.basePath === '' || typeof this._arguments.basePath === 'undefined') {
            if (pathStrings[1] === this._arguments.innerDir) {
                basePath += pathStrings[1] + '/' + (pathStrings[2] || pathStrings[2] !== '') ? pathStrings[2] : '';
                for (i = 1; i < pathStrings.length; i++) {
                    basePath += '/'+pathStrings[i];
                }
                this._arguments.rootPath = '/'+this._arguments.innerDir;
            } else {
                basePath += (pathStrings[1] || pathStrings[1] !== '') ? pathStrings[1] : '';
                for (i = 2; i < pathStrings.length; i++) {
                    basePath += '/'+pathStrings[i];
                }
            }
            this._arguments.basePath = basePath;
        } else {
            if (this._outerServerJudge() === false) {
                var basePathStrings = this._arguments.basePath.split('/');
                if (basePathStrings[1] !== this._arguments.innerDir) {
                    this._arguments.basePath = this._arguments.basePath.replace(basePathStrings[1], pathStrings[1]);
                }
                this._arguments.rootPath = '/'+this._arguments.innerDir;
            }
        }
    },

    /**
     * 実行されたサーバが「outerServerIP」に設定されたサーバかどうかを判定
     * @returns {boolean}
     * @private
     */
    _outerServerJudge: function ()
    {
        var outerServerFlg = false;
        if (document.domain.match(new RegExp("\\d{1,3}\.\\d{1,3}\.(\\d{1,3})\.\\d{1,3}"))) {
            if (199 < Number(RegExp.$1)) {
                outerServerFlg = true;
            }
        } else {
            var outerServerIPs = this._arguments.outerServerIP.split(',');
            for (var i = 0; i < outerServerIPs.length; i++) {
                if (document.domain.indexOf(outerServerIPs[i].trim()) > -1) {
                    outerServerFlg = true;
                    break;
                }
            }
        }
        return outerServerFlg;
    },

    _getDirectoryDepth: function(directory)
    {
        var depth = 0;
        var pathString = location.pathname.replace(directory, ''); // 起点までのパスを削除
        var pathStrings = pathString.split('/');
        if (pathStrings[pathStrings.length-1] !== '') {
            if (pathStrings[pathStrings.length-1].match(/\.htm/)) pathStrings[pathStrings.length-1] = '';
        }
        if (pathStrings[0] !== '' && pathStrings[1] === '') {
            depth = 1;
        } else if (pathString !== '') {
            depth = pathStrings.length - 1;
        }
        return depth;
    },

    _stripLastSlash: function(str)
    {
        if (str[str.length-1] === '/' && str.length > 1) {
            str = str.substr(0, (str.length-1));
        }
        return str;
    },

    convertDateStrToDateObj: function(dateStr)
    {
        var year = Number(dateStr.substr(0, 4));
        var month = Number(dateStr.substr(4, 2)) - 1;
        var date = Number(dateStr.substr(6, 2));
        var hour = Number(dateStr.substr(8, 2));
        var minutes = Number(dateStr.substr(10, 2));
        if (hour >= 24) {
            hour = hour - 24;
            var dateTmp = new Date(year, month, date, hour, minutes, 0);
            var tmpSec = dateTmp.getTime() + 3600 * 24 * 1000;
            dateTmp = new Date(tmpSec);
            year = dateTmp.getFullYear();
            month = dateTmp.getMonth();
            date = dateTmp.getDate();
        }
        return new Date(year, month, date, hour, minutes, 0);
    }
};

/**
 * PC用ヘッダー読み込み&反映等基本的な準備
 * @constructor
 */
var SprtTvBasicPreparationDefault = function() { this.initialize.apply(this, arguments); };
SprtTvBasicPreparationDefault.prototype = {
    initialize: function(init)
    {
        this._init = init;
        this._headerHtml = '';
        if (this._init.get('headerUriPc')[0] === '/' && this._init.get('headerUriPc').length > 1) {
            this._init.set('headerUriPc', this._init.get('headerUriPc').substr(1, (this._init.get('headerUriPc').length-1)));
        }
        var rootPath = '';
        if (this._init.get('depth') === 0) {
            rootPath = './';
        } else {
            for (var i = 0; i < this._init.get('depth'); i++) {
                rootPath += '../';
            }
        }
        this._url = rootPath+this._init.get('headerUriPc');
        this._sitePath = '';
        if (this._init.get('siteDepth') === 0) {
            this._sitePath = './';
        } else {
            for (i = 0; i < this._init.get('siteDepth'); i++) {
                this._sitePath += '../';
            }
        }
    },

    execute: function()
    {
        Event.domReady.add(function () {
            if (this._init.get('header') === true) this._loadData();
            if (Boolean(this._init.get('imgReplace')) === true) {
                var elms = null;
                for (var i=0; i<this._init.get('ImgList').length; i++) {
                    if (document.getElementById(this._init.get('ImgList')[i].id) !== null && typeof document.getElementById(this._init.get('ImgList')[i].id) !== 'undefined') {
                        document.getElementById(this._init.get('ImgList')[i].id).src = this._sitePath+this._init.get('ImgList')[i].pc;
                    } else if (this._init.get('ImgList')[i].className !== '') {
                        if (this._init.get('browser').name === "Internet Explorer" && this._init.get('browser').ver <= 8) {
                            elms = document.getElementsByTagName('img');
                            if (elms.length > 0) {
                                for (var j=0; j<elms.length; j++) {
                                    if (elms[j].className === this._init.get('ImgList')[i].className) {
                                        elms[j].src = this._sitePath+this._init.get('ImgList')[i].pc;
                                    }
                                }
                            }
                        } else {
                            elms = document.getElementsByClassName(this._init.get('ImgList')[i].className);
                            if (elms.length > 0) {
                                for (var j=0; j<elms.length; j++) {
                                    elms[j].src = this._sitePath+this._init.get('ImgList')[i].pc;
                                }
                            }
                        }
                    }
                }
            }
        }.bindFunc(this));
    },

    _loadData: function()
    {
        var usrEvtInner = new UsrEventHandler();
        var reqObj = new RequestObj(this._url, 'GET');
        var httpReq = new HttpRequest();
        httpReq.addEventListener(usrEvtInner.set(httpReq), this._loadDataComp.curry(reqObj).bindFunc(this));
        httpReq.execute(reqObj, usrEvtInner);
    },

    _loadDataComp: function(reqObj, ue)
    {
        var receiveData = null;
        if (typeof reqObj !== 'undefined') {
            if (reqObj.get('reqStatus') === 'ok') receiveData = reqObj.get('receive');
            if (this._init.get('status').mode !== 'debug') this._init.set('currentDate', new Date(reqObj.get('time')));
        }
        this._headerHtml = (receiveData !== null) ? receiveData : '';

        var generalHeaderEle = null;
        var elms = null;
        var scriptTags = this._headerHtml.match(/<script[^<]*<\/script>/g);
        if (scriptTags !== null) {
            generalHeaderEle = document.createElement('div');
            generalHeaderEle.id = 'generalHeader';
            elms = document.getElementsByTagName('body');
            elms[0].insertBefore(generalHeaderEle, elms[0].firstChild);
            document.getElementById("generalHeader").innerHTML = this._headerHtml.replace(/<script[^<]*<\/script>/, "");
            var scriptEle = null;
            for(var i = 0; i < scriptTags.length; i++) {
                scriptEle = null;
                scriptEle = document.createElement('script');
                if (scriptTags[i].match(new RegExp("(type=\")([^\"]+)(\")")) !== null) {
                    scriptEle.type = RegExp.$2;
                }
                if (scriptTags[i].match(new RegExp("(src=\")([^\"]+)(\")")) !== null) {
                    scriptEle.src = RegExp.$2;
                }
                if (scriptTags[i].match(new RegExp("(charset=\")([^\"]+)(\")")) !== null) {
                    scriptEle.charset = RegExp.$2;
                }
                elms = document.getElementsByTagName('head');
                elms[0].appendChild(scriptEle);
            }
        } else {
            generalHeaderEle = document.createElement('div');
            generalHeaderEle.id = 'generalHeader';
            elms = document.getElementsByTagName('body');
            elms[0].insertBefore(generalHeaderEle, elms[0].firstChild);
            document.getElementById("generalHeader").innerHTML = this._headerHtml;
        }
    }
};

/**
 * スマホ用ヘッダー読み込み&反映等基本的な準備
 * @type {*}
 */
var SprtTvBasicPreparationSmp = function() { this.initialize.apply(this, arguments); }.extend(SprtTvBasicPreparationDefault);
SprtTvBasicPreparationSmp.prototype.initialize = function(init)
{
    this._init = init;
    this._headerHtml = '';
    this._url = '';
    this._sitePath = '';
    if (this._init.get('siteDepth') === 0) {
        this._sitePath = './';
    } else {
        for (var i = 0; i < this._init.get('siteDepth'); i++) {
            this._sitePath += '../';
        }
    }
};

SprtTvBasicPreparationSmp.prototype.execute = function(init)
{
    Event.domReady.add(function () {
        if (this._init.get('imgReplace') === true) {
            var elms = null;
            for (var i=0; i<this._init.get('ImgList').length; i++) {
                if (document.getElementById(this._init.get('ImgList')[i].id) !== null && typeof document.getElementById(this._init.get('ImgList')[i].id) !== 'undefined') {
                    document.getElementById(this._init.get('ImgList')[i].id).src = this._sitePath+this._init.get('ImgList')[i].smp;
                } else if (this._init.get('ImgList')[i].className !== '') {
                    if (this._init.get('browser').name === "Internet Explorer" && this._init.get('browser').ver <= 8) {
                        elms = document.getElementsByTagName('img');
                        if (elms.length > 0) {
                            for (var j=0; j<elms.length; j++) {
                                if (elms[j].className === this._init.get('ImgList')[i].className) {
                                    elms[j].src = this._sitePath+this._init.get('ImgList')[i].smp;
                                }
                            }
                        }
                    } else {
                        elms = document.getElementsByClassName(this._init.get('ImgList')[i].className);
                        if (elms.length > 0) {
                            for (var j=0; j<elms.length; j++) {
                                elms[j].src = this._sitePath+this._init.get('ImgList')[i].smp;
                            }
                        }
                    }
                }
            }
        }
    }.bindFunc(this));
};

/**
 * JS CSS 出し分け（PC）
 * @constructor
 */
var SprtTvHeaderWriterDefault = function() { this.initialize.apply(this, arguments); };
SprtTvHeaderWriterDefault.prototype = {
    initialize: function(init)
    {
        this._init = init;
        this._rootPath = '';
        var i = 0;
        if (this._init.get('depth') === 0) {
            this._rootPath = './';
        } else {
            for (i = 0; i < this._init.get('depth'); i++) {
                this._rootPath += '../';
            }
        }
        this._sitePath = '';
        if (this._init.get('siteDepth') === 0) {
            this._sitePath = './';
        } else {
            for (i = 0; i < this._init.get('siteDepth'); i++) {
                this._sitePath += '../';
            }
        }
        //this._path = (this._init.get('page') == 'pages') ? '../' : './';
    },

    execute: function()
    {
        this._writer();

        // 本番のドメイン接続の場合のみ（IP接続の場合はCDPタグ設置でエラーになるため）
        if (location.host.match(/asahi\.co\.jp/)) {
            // CDPタグの設置
            document.write('<script src="/common/js/tv_td.js"></script>'+"\n");
            // FourM (広告) オーバーレイ広告のタグ
            this._advertisement();
        }
    },

    _writer: function()
    {
    },

    /**
     * advertisement
     * @private
     */
    _advertisement: function()
    {
        document.write('<script type="application/javascript" src="//anymind360.com/js/6829/ats.js"></script>'+"\n");
    }
};

/**
 * JS CSS 出し分け（SMP）
 * @constructor
 */
var SprtTvHeaderWriterSmp = function() { this.initialize.apply(this, arguments); };
SprtTvHeaderWriterSmp.prototype = {
    initialize: function(init)
    {
        this._init = init;
        this._rootPath = '';
        var i = 0;
        if (this._init.get('depth') === 0) {
            this._rootPath = './';
        } else {
            for (i = 0; i < this._init.get('depth'); i++) {
                this._rootPath += '../';
            }
        }
        this._sitePath = '';
        if (this._init.get('siteDepth') === 0) {
            this._sitePath = './';
        } else {
            for (i = 0; i < this._init.get('siteDepth'); i++) {
                this._sitePath += '../';
            }
        }
    },

    execute: function()
    {
        this._writer();

        // 本番のドメイン接続の場合のみ（IP接続の場合はCDPタグ設置でエラーになるため）
        if (location.host.match(/asahi\.co\.jp/)) {
            // CDPタグの設置
            document.write('<script src="/common/js/tv_td.js"></script>'+"\n");
            // FourM (広告) オーバーレイ広告のタグ
            this._advertisement();
        }
    },

    // ==JS CSS 出し分け（SMP）=====================================================
    _writer: function()
    {
    },

    /**
     * advertisement
     * @private
     */
    _advertisement: function()
    {
        document.write('<script type="application/javascript" src="//anymind360.com/js/6829/ats.js"></script>'+"\n");
    }
};

/**
 * ソーシャルリンク用（オプション）
 * @constructor
 */
var SprtTvSeparatorSocialLink = function () { this.initialize.apply(this, arguments); };
SprtTvSeparatorSocialLink.prototype = {
    initialize: function (init)
    {
        this._init = init;
        this._usrEvt = null;
        this._genre = 'pc';
    },

    execute: function ()
    {
        if (typeof this._init.get('snsLinkSelector') !== 'undefined') this._genre = this._init.get('snsLinkSelector');
        if (this._init.get('browser').genre === 'sp' && (this._genre === 'smp' || this._genre === 'sp' || this._genre === 'both')) {
            this._setSbLink();
        } else if ( this._genre === 'pc' || this._genre === 'both') {
            this._setSbLink();
        }
    },

    _setSbLink: function ()
    {
        var url = window.location.href;
        var url_encoded = encodeURIComponent(url);
        var ttl = encodeURIComponent(this._init.get('fbTitle'));
        var twttl = encodeURIComponent(this._init.get('twMain'));

        var sbLink = '<ul id="sideMenuCont">'+"\n";
        //facebook
        sbLink += '<li class="facebook"><a href="http://www.facebook.com/sharer.php?u='+url+'&t='+ttl+'" target="_blank"><img src="img/common/btn_fb_off.png" alt="Facebookでシェアする" title="Facebookでシェアする"></a></li>'+"\n";
        //twitter
        sbLink += '<li class="twitter"><a href="http://twitter.com/intent/tweet?text='+twttl+'&url='+url_encoded+' '+'" target="_blank"><img src="img/common/btn_tw_off.png" alt="Twitterでつぶやく" title="Twitterでつぶやく"></a></li> '+"\n";
        sbLink += '</ul>'+"\n";
        //Event.domReady.add(function () {
        document.getElementById(this._init.get('snsLinkPlaceHolderID')).innerHTML = sbLink;
        //}.bindFunc(this));
    }
};

/**
 * 実行用クラス
 * @constructor
 */
var SprtTv = function() { this.initialize.apply(this, arguments); };
SprtTv.prototype = {
    initialize: function()
    {
        this._init = new SprtTvInit();
        this._pgm = null;
        this._preparater = null;
        this._writer = null;
        this._snsLinker = null;
        if (this._init.get('browser').genre === 'sp') {
            this._writer = new SprtTvHeaderWriterSmp(this._init);
        } else {
            this._writer = new SprtTvHeaderWriterDefault(this._init);
        }
    },

    execute: function()
    {
        this._fire();
        this._writer.execute();
        this._fireDelayed()
    },

    _fire: function()
    {
        if (this._init.get('browser').genre === 'sp') {
            this._preparater = new SprtTvBasicPreparationSmp(this._init);
        } else {
            this._preparater = new SprtTvBasicPreparationDefault(this._init);
        }
        this._preparater.execute();
        if (this._init.get('snsLinkSelector') !== 'none' && typeof this._init.get('snsLinkSelector') !== 'undefined') {
            this._snsLinker = new SprtTvSeparatorSocialLink(this._init);
        }
    },

    _fireDelayed: function()
    {
        Event.domReady.add(function () {
            if (this._init.get('browser').genre === 'sp') {
                if (this._init.get('tanpatsuPage') === true) {
                    $("#gNav p").click(function(){
                        if($("#gNav ul").css("display") === "block") {
                            $("#gNav ul").slideUp("nomal");
                            $('#navClickArea').css('display','none');
                        } else {
                            $("#gNav ul").slideDown("nomal");
                            var wH = $("#wrap").height();
                            var wW = $("#wrap").width();
                            $('#navClickArea').css('height',wH+'px');
                            $('#navClickArea').css('width',wW+'px');
                            $('#navClickArea').css('display','block');
                        }
                    });
                    $("#gNav li a").click(function(){
                        $("#gNav ul").css("display","none");
                    });
                    $("#navClickArea").click(function(){
                        $("#gNav ul").slideUp("nomal");
                        $('#navClickArea').css('display','none');
                    });
                    $('#header').waypoint('sticky');
                    if (this._init.get('owlCarousel') === true) {
                        $(".owl-carousel").owlCarousel();
                    }
                }
            }
            if (this._init.get('snsLinkSelector') !== 'none' && typeof this._init.get('snsLinkSelector') !== 'undefined') {
                this._snsLinker.execute();
            }
        }.bindFunc(this));
    }
};

/**
 * 実際の実行は継承先で行う事
 * @type {SprtTv}
 */
//var SprtTv = new SprtTv(new SprtTvInit());
//SprtTv.execute();